//{$WARNINGS OFF}
//=============================================================================
//  plPanelTrackBarEditR|[lg
//
//  R|[lgƂTTrackBarTEditplR|[lg
//  TTrackBarTEdit̓TuR|[lgƂȂĂ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ܂Czz̍ہCȂ闝R낤Ƃɑ㉿߂邱Ƃ֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2009N0108 `
//  2013N1031 R[h𐮔āCWindows 7 U64(SP1) + Delphi XE ProœmF
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plPanelTrackBarEditEx;

interface

uses
  SysUtils, Classes, Controls, ExtCtrls, StdCtrls, ComCtrls, Graphics;

type
  //OQ
  TplTrackBar = class;
  TplEditSP   = class;

  TplPanelTrackBarEditEx = class(TPanel)
  private
    { Private 錾 }
    FTrackBar : TplTrackBar;
    FEdit     : TplEditSP;
  protected
    { Protected 錾 }
    procedure SetParent(AParent: TWinControl); override;
    procedure Resize; override;
  public
    { Public 錾 }
    constructor Create( AOwner: TComponent); override;
    destructor  Destroy; override;
  published
    { Published 錾 }
    //TuR|[lg̓[hI[Ƃ
    property TrackBar : TplTrackBar read FTrackBar;
    property Edit     : TplEditSP   read FEdit;
  end;

  //Rg[ŃTuR|[lgTTrackBar
  TplTrackBar = class(TTrackBar)
  private
    FPanelTrackBarEditEx : TplPanelTrackBarEditEx;
  protected
    procedure Changed; override;
  public
    constructor Create( AOwner: TComponent); override;
    property PanelTrackBarEditEx : TplPanelTrackBarEditEx read FPanelTrackBarEditEx;
  end;

  //Rg[ŃTuR|[lgTEdit
  TplEditSP = class(TCustomEdit)
  private
    FPanelTrackBarEditEx : TplPanelTrackBarEditEx;
  protected
    procedure Change; override;
    procedure DoEnter; override;
    procedure KeyPress(var Key: Char); override;
  public
    constructor Create( AOwner: TComponent); override;
    property PanelTrackBarEditEx : TplPanelTrackBarEditEx read FPanelTrackBarEditEx;
  published
    property Text;
  end;

procedure Register;

implementation

{ TplTrackBarEditEx }

//-----------------------------------------------------------------------------
//  R|[lgCreate
//  rWAȓR|[lgSetParentŐ
//  rWAȓR|[lgCreateŐĂ悢
//-----------------------------------------------------------------------------
constructor TplPanelTrackBarEditEx.Create(AOwner: TComponent);
begin
  inherited;

  Caption := '';
  Width   := 250;
  Height  := 85;
  Color   := $00AFBBA6;

  //ꂪȂTPanelColorvpeB̐ݒ肪fȂꍇ
  Self.ParentBackground := False;
end;

//-----------------------------------------------------------------------------
//  R|Destroy
//  R|[lg
//-----------------------------------------------------------------------------
destructor TplPanelTrackBarEditEx.Destroy;
begin
  if Assigned(FTrackBar) then FreeAndNil(FTrackBar);
  if Assigned(FEdit)     then FreeAndNil(FEdit);

  inherited;
end;

//-----------------------------------------------------------------------------
//  R|SetParent
//  rWAȓR|[lgSetParentŐ
//  SetParent\bh͉ďôŒ
//-----------------------------------------------------------------------------
procedure TplPanelTrackBarEditEx.SetParent(AParent: TWinControl);
begin
  inherited;

  if AParent = nil then exit;

  Caption := '';

   if not Assigned(FTrackBar) then begin
    FTrackBar := TplTrackBar.Create(Self);

    FTrackBar.Parent    := Self;
    FTrackBar.Left      := 10;
    FTrackBar.Top       := 10;
    FTrackBar.Height    := 35;
    FTrackBar.Width     := Self.Width - 20;
    FTrackBar.Min       := 0;
    FTrackBar.Max       := 100;
    FTrackBar.Frequency := 10;
    FTrackBar.TickStyle := tsNone;
    FTrackBar.FPanelTrackBarEditEx := Self;
  end;

  if not Assigned(FEdit) then begin
    FEdit := TplEditSP.Create(Self);

    FEdit.Parent := Self;
    FEdit.Left   := FTrackBar.Left + 5;
    FEdit.Top    := FTrackBar.Top + FTrackBar.Height + 3;
    FEdit.Width  := 45;
    FEdit.FPanelTrackBarEditEx := Self;
  end;
end;

//-----------------------------------------------------------------------------
//  R|Resize\bh
//  R|[lgTTrackBar̃TCYύX
//-----------------------------------------------------------------------------
procedure TplPanelTrackBarEditEx.Resize;
begin
  inherited;
  if not Assigned(FTrackBar) then exit;

  FTrackBar.Width := Self.Width - 20;
end;

{ TplTrackBar }

//-----------------------------------------------------------------------------
//  R|[lgTplTrackBarCreate\bh
//-----------------------------------------------------------------------------
constructor TplTrackBar.Create(AOwner: TComponent);
begin
  inherited;
  //TuR|[lgɂ
  SetSubComponent(True);
end;

//-----------------------------------------------------------------------------
//  R|[lgTplTrackBarChange\bh
//-----------------------------------------------------------------------------
procedure TplTrackBar.Changed;
begin
  inherited;
  FPanelTrackBarEditEx.FEdit.Text := IntTostr(Self.Position);
end;

{ TplEditSP }

//-----------------------------------------------------------------------------
//  R|[lgTplEditSPCreate\bh
//-----------------------------------------------------------------------------
constructor TplEditSP.Create(AOwner: TComponent);
begin
  inherited;
  //TuR|[lgɂ
  SetSubComponent(True);
end;

//-----------------------------------------------------------------------------
//  R|[lgTplEditSPChange\bh
//-----------------------------------------------------------------------------
procedure TplEditSP.Change;
begin
  inherited;
  FPanelTrackBarEditEx.FTrackBar.Position :=
            StrToIntDef(FPanelTrackBarEditEx.FEdit.Text, 0);
end;

//-----------------------------------------------------------------------------
//  R|[lgTplEditSPDoEnter\bh
//-----------------------------------------------------------------------------
procedure TplEditSP.DoEnter;
begin
  inherited;

  //Ȋ͂sɂĂ܂
  SetImeMode(Handle, imDisable);
end;

//-----------------------------------------------------------------------------
//  R|[lgTplEditSPKeyPress\bh
//-----------------------------------------------------------------------------
procedure TplEditSP.KeyPress(var Key: Char);
begin
  //lȊO͓͂Ȃ
  //p͓͂łȂ. #8[BackSpace]. #27[Escape]
  if ((Key >= '0') and (Key <= '9')) or (Key = #8) or (Key = #27) then begin
    inherited KeyPress(Key);
  end else begin
    Key := #0;
  end;
end;

//-----------------------------------------------------------------------------
//  R|[lgo^
//-----------------------------------------------------------------------------
procedure Register;
begin
  RegisterComponents('plXRAY', [TplPanelTrackBarEditEx]);
end;

end.
